
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Webhook_subscriptionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const webhook_subscriptions = await db.webhook_subscriptions.create(
            {
                id: data.id || undefined,
        
        event_type: data.event_type
        ||
        null
            ,
            
        enabled: data.enabled
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await webhook_subscriptions.setWebhook( data.webhook || null, {
            transaction,
        });
        
        await webhook_subscriptions.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return webhook_subscriptions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const webhook_subscriptionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                event_type: item.event_type
            ||
            null
            ,
            
                enabled: item.enabled
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const webhook_subscriptions = await db.webhook_subscriptions.bulkCreate(webhook_subscriptionsData, { transaction });

        // For each item created, replace relation files
        

        return webhook_subscriptions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const webhook_subscriptions = await db.webhook_subscriptions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.event_type !== undefined) updatePayload.event_type = data.event_type;
        
        
        if (data.enabled !== undefined) updatePayload.enabled = data.enabled;
        
        
        updatePayload.updatedById = currentUser.id;

        await webhook_subscriptions.update(updatePayload, {transaction});

        
        
        if (data.webhook !== undefined) {
            await webhook_subscriptions.setWebhook(
              
              data.webhook,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await webhook_subscriptions.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return webhook_subscriptions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const webhook_subscriptions = await db.webhook_subscriptions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of webhook_subscriptions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of webhook_subscriptions) {
                await record.destroy({transaction});
            }
        });


        return webhook_subscriptions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const webhook_subscriptions = await db.webhook_subscriptions.findByPk(id, options);

        await webhook_subscriptions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await webhook_subscriptions.destroy({
            transaction
        });

        return webhook_subscriptions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const webhook_subscriptions = await db.webhook_subscriptions.findOne(
            { where },
            { transaction },
        );

        if (!webhook_subscriptions) {
            return webhook_subscriptions;
        }

        const output = webhook_subscriptions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.webhook = await webhook_subscriptions.getWebhook({
            transaction
        });
        
        
        output.organizations = await webhook_subscriptions.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.webhooks,
        as: 'webhook',
        
        where: filter.webhook ? {
          [Op.or]: [
            { id: { [Op.in]: filter.webhook.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.webhook.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.event_type) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'webhook_subscriptions',
                        'event_type',
                        filter.event_type,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.enabled) {
                where = {
                    ...where,
                enabled: filter.enabled,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.webhook_subscriptions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'webhook_subscriptions',
                        'event_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.webhook_subscriptions.findAll({
            attributes: [ 'id', 'event_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['event_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.event_type,
        }));
    }

    
};

